#include "Main.h"
#include "WGetHTTP.h"

#include <obstack.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

char *WGetHTTP::get_host(char *url)
{
	char *stringStart = strstr(url, "//") + 2;
	char *stringEnd = strstr(stringStart, "/");
	int stringLen = stringEnd - stringStart;
	
	char *host = new char[stringLen + 1];
	memcpy(host, stringStart, stringLen);
	host[stringLen] = 0;
	
	return host;
}

char *WGetHTTP::get_page(char *url)
{
	char *stringStart = strstr(strstr(url, "//") + 2, "/");
	int stringLen = strlen(stringStart);
	
	char *page = new char[stringLen + 1];
	strcpy(page, stringStart);
	
	return page;
}

int WGetHTTP::make_socket(char *host)
{
	int soc = socket(AF_INET, SOCK_STREAM, 0);
	
	struct hostent *ip = gethostbyname(host);
	if(!ip) return -1;
		
	struct sockaddr_in addr;
	memset((char*)&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr = *(struct in_addr*)ip->h_addr;
	addr.sin_port = htons(80);
	
	if(connect(soc, (sockaddr*)&addr, sizeof(addr)) < 0)
		return -1;
	else
		return soc;
	
}

void WGetHTTP::read_http(int soc, char *page, char* host)
{
	char request[] = "GET ";
	char finish[] = " HTTP/1.0\n";
	char extra1[] = "Host: ";
	char extra2[] = "\n\n";	

	if(send(soc, request, strlen(request), 0) < 0)
		return;
	if(send(soc, page, strlen(page), 0) < 0)
		return;
	if(send(soc, finish, strlen(finish), 0) < 0)
		return;
	if(send(soc, extra1, strlen(extra1), 0) < 0)
		return;
	if(send(soc, host, strlen(host), 0) < 0)
		return;
	if(send(soc, extra2, strlen(extra2), 0) < 0)
		return;
	
	int data_cur = 0;
	char buf[2048];
	int avail;
	while(1)
	{
		avail = recv(soc, buf, sizeof(buf), 0);
		data = (char*)realloc(data, data_cur + avail + 1);
		memcpy(data+data_cur, buf, avail);
		data_cur += avail;
		data[data_cur] = 0;
		
		if(strstr(data, "</html>")) break;
		if(strstr(data, "</HTML>")) break;
	}
}

WGetHTTP::WGetHTTP(char *url)
{
	data = 0;
	char *host = get_host(url);
	int soc = make_socket(host);
	
	char *page = get_page(url);
	read_http(soc, page, host);
	
	delete[] host;
	delete[] page;
}

WGetHTTP::~WGetHTTP(void)
{
	free(data);
}

char* WGetHTTP::getData(void)
{
	return data;
}
