#ifndef _wview_h_
#define _wview_h_

#include <View.h>

class WPrefs;
class WWeather;
class BBItmap;
class BView;
class BFont;
class BMessageRunner;
class BPopUpMenu;
class BMenuItem;

enum
{
	WV_HTTP_DONE = 'wvhd',
	
	WV_INDESKBAR = 'wvid',
	WV_ABOUT = 'wvab',
	WV_PREFERENCES = 'wvpr',
	WV_UPDATE = 'wvup',
	WV_INFO = 'wvif',
	WV_QUIT = 'wvqu',
	
	WV_CONTEXT = 'wvco'
};

class _EXPORT WView;

class WView : public BView
{
	public:
		WView(BRect rect, WPrefs *iprefs);
		WView(BMessage *archive);
		~WView(void);
		
		void Init(void);
		void Quit(void);
		bool QuitRequested(void);
		void MessageReceived(BMessage *message);
		void MouseDown(BPoint point);
		void MouseUp(BPoint point);
		void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
		void AttachedToWindow(void);
		
		void WriteTempFiles(void);
		void OpenPrefs(void);
		void ClosePrefs(void);
		void OpenInfo(void);
		void CloseInfo(void);
		void OpenContext(BPoint point);
		void CloseContext(void);
		void SetContext(BPoint point);
		void SetPulse(void);
		
		void Draw(BRect rect);
		void MakeImage(void);
		void UpdateImage(void);
		
		static bool IsInDeskbar(void);
		static void AddToDeskbar(WPrefs *prefs);
		static void RemoveFromDeskbar(void);
		
		static BArchivable *Instantiate(BMessage *data);
		status_t Archive(BMessage *data, bool deep = true) const;
	public:
		bool updating, replicant;
		WPrefs *prefs;
		BMessenger *prefsmsger, *infomsger;
		
		BBitmap *image;
		BView *imageBitch;
		BFont *font;
		
		BPopUpMenu *contextmenu;
		BMenuItem *mDeskbar, *mAbout, *mPreferences, *mUpdate, *mInfo, *mQuit;
		
		WWeather *weather;
		BMessageRunner *pulseRun, *contextRun;
		BPoint lastMouse;
		bool dblClickValid;
};

#endif
