#include "Main.h"
#include "WWindow.h"

#include "WPrefs.h"
#include "WView.h"
#include <Application.h>
#include <Message.h>

WWindow::WWindow(WPrefs *iprefs)
	: BWindow(iprefs->opWinRect,
		APP_NAME, B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE),
	prefs(iprefs)
{
	/*BView *cover = new BView(Bounds(), "",
		B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW);
	cover->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(cover);*/

	view = new WView(Bounds(), iprefs);
	/*cover->*/AddChild(view);
	
	AddShortcut('d', B_COMMAND_KEY, new BMessage(WV_INDESKBAR), view);
	AddShortcut('a', B_COMMAND_KEY, new BMessage(WV_ABOUT), view);
	AddShortcut('p', B_COMMAND_KEY, new BMessage(WV_PREFERENCES), view);
	AddShortcut('i', B_COMMAND_KEY, new BMessage(WV_INFO), view);
	AddShortcut('u', B_COMMAND_KEY, new BMessage(WV_UPDATE), view);
}

bool WWindow::QuitRequested(void)
{
	if(view->QuitRequested())
	{
		prefs->sem.get();
		prefs->opWinRect = Frame();
		prefs->sem.rel();
		be_app->PostMessage(new BMessage(B_QUIT_REQUESTED));
		return true;
	}
	else
		return false;
}
